import Vue from 'vue';
import _ from 'lodash';
var moment = require('moment');
const Plugin = {
  install(Vue, options) {
    Vue.prototype.$checkDate = (startStr, endStr, vacation = []) => {
      let res = true;
      let cbt = (time, vs, ve) => {
        let r = moment(time).isBetween(vs, ve, null, '[]');
        if (r) res = false;
        return r;
      };
      for (const vac of vacation) {
        if (moment(startStr).isBefore(vac.start)) {
          if (cbt(endStr, vac.start, vac.end)) {
            res = vac;
            break;
          }
        } else {
          if (cbt(startStr, vac.start, vac.end)) {
            res = vac;
            break;
          }
        }
      }
      return res;
    };
    Vue.prototype.$tqInRange = (start, end, ranges) => {
      let res = { result: false };
      //开始时间
      for (const range of ranges) {
        let { start: s, end: e } = range;
        //开始时间在范围开始前=>说明检测的时间段不在这个范围内;继续循环
        if (moment(start).isBefore(s)) continue;
        //开始时间是否在范围内=>true:说明在,继续检查end在不在范围内;false:不在范围内;继续循环
        if (!moment(start).isBetween(s, e, null, '[]')) continue;
        //结束时间是否在范围内=>true:说明检测的时间段在该范围内,break;false=>说明不行;继续循环
        if (moment(end).isBetween(s, e, null, '[]')) {
          res.result = true;
          res.checkData = { start, end };
          res.range = range;
        }
      }
      return res;
    };
    Vue.prototype.$plusDay = (date, day = 1) => {
      return moment(date)
        .add(day, 'days')
        .format('YYYY-MM-DD');
    };
  },
};
Vue.use(Plugin);
