import Vue from 'vue';
import Vuex from 'vuex';
import classes from '@frame/store/classes';
import dept from '@frame/store/dept';
import location from '@frame/store/location';
import bedroom from '@frame/store/bedroom';
import director from '@frame/store/director';
import student from '@frame/store/student';
import task from '@frame/store/task';
import subject from '@frame/store/subject';
import question from '@frame/store/question';
import questionnaire from '@frame/store/questionnaire';
import questionanswer from '@frame/store/question-answer';
import teacher from '@frame/store/teacher';
import trainplan from '@frame/store/trainplan';
import duty from '@frame/store/duty';
import school from '@frame/store/school';
import schPlan from '@frame/store/sch-plan';
import teaPlan from '@frame/store/tea-plan';
import lesson from '@frame/store/lesson';
import trainTemplate from '@frame/store/train-template';
import leave from '@frame/store/leave';
import util from '@frame/store/util';
import count from '@frame/store/count';
import setting from '@frame/store/setting';
import trainBatch from '@frame/store/train-plan-year';
import attendance from '@frame/store/attendance';
import group from '@frame/store/group';
import uploadtask from '@frame/store/uploadtask';
import nation from '@frame/store/nation';
import completion from '@frame/store/question-completion';
import termquest from '@frame/store/termquest';
import dirPlan from '@frame/store/dir-plan';
import login from '@frame/store/login';
import notice from '@frame/store/notice';
import * as ustate from '@frame/store/user/state';
import * as umutations from '@frame/store/user/mutations';
import * as dostate from '@frame/store/setting/state';
import * as domutations from '@frame/store/setting/mutations';

import other from '@frame/store/other';

Vue.use(Vuex);

export default new Vuex.Store({
  modules: {
    dept,
    classes,
    location,
    bedroom,
    director,
    student,
    task,
    subject,
    question,
    questionnaire,
    questionanswer,
    teacher,
    trainplan,
    duty,
    schPlan,
    school,
    teaPlan,
    lesson,
    nation,
    completion,
    termquest,
    login,
    dirPlan,
    leave,
    trainTemplate,
    other,
    util,
    count,
    setting,
    trainBatch,
    attendance,
    group,
    uploadtask,
    notice,
  },
  state: { ...ustate, ...dostate },
  mutations: { ...umutations, ...domutations },
  actions: {},
});
