const path = require('path');
const frame = path.resolve(__dirname, '../frame');
const school = path.resolve(__dirname, '../train-school');
module.exports = {
  publicPath: process.env.NODE_ENV === 'development' ? '/' : '/center',
  outputDir: 'center',
  configureWebpack: {
    // externals: {
    //   'element-ui': 'Element',
    //   vue: 'Vue',
    // },
    // 开发生产共同配置
    resolve: {
      alias: {
        '@': path.resolve(__dirname, './src'),
        '@c': path.resolve(__dirname, './src/components'),
        '@a': path.resolve(__dirname, './src/assets'),
        '@frame': frame,
        '@school': school,
      },
    },
  },
  devServer: {
    port: '8002',
    //api地址前缀
    proxy: {
      '/api/train': {
        target: 'http://free.liaoningdoupo.com', ///api/train
        changeOrigin: true,
        ws: true,
      },
      '/files': {
        target: 'http://free.liaoningdoupo.com',
        changeOrigin: true,
        ws: true,
      },
      '/ws': {
        target: 'http://free.liaoningdoupo.com',
        ws: true,
      },
      '/weixin': {
        target: 'http://smart.cc-lotus.info',
        changeOrigin: true,
        ws: true,
      },
      '/jh': {
        //聚合科技API
        target: 'http://v.juhe.cn',
        changeOrigin: true,
        ws: true,
        pathRewrite: {
          '^/jh': '',
        },
      },
    },
  },
};
